# -*- coding: utf-8 -*-

"""Main module."""
import random
import discord
import os
import requests
import aiocron
import asyncio
import giphy_client
import gitlab
import lxml

from time import sleep
from discord.ext import tasks, commands
from subprocess import *
from sys import argv
from pathlib import Path
from giphy_client.rest import ApiException
from bs4 import BeautifulSoup as bs

class Mybot(commands.Cog):
    def __init__(self, bot):
        self.bot = bot
        self.sounds = []
        self.sounds_history = []
        self.play_next.start()

    @commands.command()
    async def join(self, ctx):
        channel = [x for x in self.bot.get_all_channels() if x.name == "Général"][0]
        await channel.connect()
        sleep(2)

    @commands.command()
    async def disconnect(self, ctx):
        await ctx.guild.voice_client.disconnect()

    @commands.guild_only()
    @commands.command()
    async def joke(self, ctx, folder=None):
        user = ctx.message.author.name
        if not folder or not ctx.message.content:
            audio_file = random.choice([f for f in Path('/home/mika/kabot/kabot/kabot/Audio/').glob('**/*.mp3')])
        else:
            folder = folder.lower()
            audio_file = random.choice([f for f in Path('/home/mika/kabot/kabot/kabot/Audio/').glob('**/*.mp3') if folder in str(f).lower()])
        self.sounds.append((audio_file,ctx))

    @commands.command()
    async def repeat(self, ctx):
        #if ctx.message.author.name == self.bot.user.name:
        #    return
        user = ctx.message.author.name
        source = self.sounds_history[0]
        self.sounds.append(source)

    @commands.command(help='Gif me')
    async def gif(self, ctx):
        query = ctx.message.content.replace('!gif ','')
        print(query)
        api_instance = giphy_client.DefaultApi()
        api_key = "udhL9Rgdme3HpAoFhWVZoYM0l0XwkzLz"
        lang = 'fr'
        try:
            api_response = api_instance.gifs_search_get(api_key, query, lang=lang, limit=10)
            api_response.to_dict()['data'][0]
            get_url = random.choice(api_response.to_dict()['data'])
            get_url['url']
            await ctx.channel.send(get_url['url'])
        except ApiException as e:
            await ctx.channel.send("Exception when calling DefaultApi->gifs_search_get: %s\n" % e)

    @commands.command()
    async def welcome(self, ctx):
        #if ctx.message.author.name == self.bot.user.name:
        #    return
        user = ctx.message.author.name
        print(user)
        try:
            audio_file = random.choice([f for f in os.listdir('/home/mika/kabot/kabot/kabot/Audio/%s/' % user) if f.endswith('.mp3')])
            audio_file = '/home/mika/kabot/kabot/kabot/Audio/%s/' % user + audio_file
        except:
            audio_file = random.choice([f for f in Path('/home/mika/kabot/kabot/kabot/Audio/').glob('**/*.mp3')])
        self.sounds.append((audio_file,ctx))

    @commands.command(help='Update local repo')
    async def update(self, message):
        output = Popen('git pull'.split(), stdout=PIPE).communicate()[0]
        await message.channel.send(output.decode('utf-8'))

    @commands.command(help='Restart Bot')
    async def restart(self, ctx):
        await self.bot.logout()

    @commands.command(help='Restart Bot')
    async def restart_queue(self, ctx):
        self.play_next.restart()

    @commands.command(help='check if bot always online')
    async def ping(self, message):
        await message.channel.send('pong')

    @commands.command(help='count lines numbers in quote file')
    async def lines(self, ctx):
        path = '/home/mika/.kabot/%s.log' % ctx.channel
        with open(path, 'r') as f:
            lines = f.read().splitlines()
        nb_lines = len(lines)
        await ctx.channel.send("j'ai %s lignes dans mon stock" % nb_lines)

    @commands.command(help='slap this ass')
    async def slap(self, ctx, user=None):
        slap_multiple = [
                "%s prend un coup de pied au cul",
                "Descente du coude sur %s",
                "%s est propulsé par dessus la TROISIEME CORDE!",
                "Le mec en rose, c'est moi et le mec en jaune c'est %s! https://giphy.com/gifs/gSIz6gGLhguOY",
                ]
        if not user or not ctx.message.mentions:
            online_members = []
            members = ctx.guild.members
            for member in members:
                if str(member.status) == "online":
                    online_members.append(member)
            user = random.choice(online_members)
            user = user.mention
        elif ctx.message.mentions:
            user = ctx.message.mentions[0]
            user = user.mention
        if user == self.bot.user.mention:
            await ctx.channel.send("je tribuche par terre et je sais pas comment")
        else:
            await ctx.channel.send(random.choice(slap_multiple) % user)

    @commands.command(help="Interrogation issues")
    async def issue(self, ctx, *args):
        if args:
            args = list(args)
            gl = gitlab.Gitlab('https://git.0w.tf/', private_token='VHLsCQTcjF3oxujqFRYz')
            gl.auth()
            if args[0] == 'list':
                projects = gl.projects.list(search='Kabot')[0]
                issues = projects.issues.list()
                for issue in issues:
                    if "closed" == issue.state:
                        pass
                    else:
                        await ctx.channel.send('#' + str(issue.id) + ": " + issue.title + '\n' + issue.web_url)
            elif args[0] == 'search':
                query = ''.join(args[1:])
                project = gl.projects.list(search='Kabot')[0]
                find_issues = project.search("issues", query)
                for issue in find_issues:
                    await ctx.channel.send("#" + str(issue['id']) + ": " + issue['title'] + '\n' + issue['web_url'])
            elif args[0] == 'add':
                title = ' '.join(args[1:])
                projects = gl.projects.list()
                for project in projects:
                    if "Kabot" == project.name:
                        issue = project.issues.create({'title': title})
                        await ctx.channel.send(issue.web_url)
            else:
                await ctx.channel.send('unknown command')

    @commands.command(help="optionnal args : [livre] [character]")
    async def kaamelott(self, ctx, *args):
        response = None
        url = 'https://kaamelott.chaudie.re/api/random'
        if args and ctx.message.content:
            args = list(args)
            if args[0].isdigit():
                livre = int(args[0])
                args.pop(0)
            elif args[-1].isdigit():
                livre = int(args[-1])
                args.pop(-1)
            else:
                livre = None
            if args:
                perso = ' '.join(args)
            if perso and livre:
                url = 'https://kaamelott.chaudie.re/api/random/livre/%s/personnage/%s' % (livre,perso)
            elif perso:
                url = 'https://kaamelott.chaudie.re/api/random/personnage/%s' % perso
            else:
                url = 'https://kaamelott.chaudie.re/api/random/livre/%s' % livre
        try:
            citation = requests.get(url).json()['citation']
            response = "%s :\n```\n%s\n```" % (citation['infos']['personnage'], citation['citation'])
        except:
            response = "Unknow error, try: !kaamelott [livre] [character]"
        await ctx.send(response)

    @commands.command(help="Je menotte une cornemuse et je fume Eddy Malou")
    async def kamoulox(self, ctx):
        sans_verbe = get_word('nom').text + " " + get_word('complement').get('m') + " et " + get_word('nom').text + " " + get_word('complement').get('m') + "."
        nom1 = get_word('nom')
        nom2 = get_word('nom')
        un1 = "un"
        un2 = "un"
        if nom1.get('gender') == 'F':
            un1 = "une"
        if nom2.get('gender') == 'F':
            un2 = "une"
        phrase1 = get_word('verbe').text + " " + un1 + " " + nom1.text + " " + random.choice([get_word('complement').get('m'), ""])
        phrase2 = get_word('verbe').text + " " + un2 + " " + nom2.text + " " + random.choice([get_word('complement').get('m'), ""])
        avec_verbe = phrase1 + " et " + phrase2 + "."
        piece = random.choice(['pile', 'face'])
        if piece == "pile":
            result = sans_verbe
        elif piece == "face":
            result = avec_verbe
        await ctx.send(result)

    @commands.command(help="Toi tu fermes ta gueule! Tu la fermes définitivement")
    async def mute(self, ctx, member: discord.Member=None, mute_time = 10):
        if member.voice.mute:
            await ctx.channel.send("Tu ne vas pas m'avoir si facilement")
            return
        if not member:
            await ctx.channel.send("Qui veux-tu mute?")
            return
        if mute_time > 60:
            await ctx.channel.send("Doucement sur le temps!")
            return
        member = ctx.message.mentions[0]
        await member.edit(mute=True)
        await ctx.send("Tu sors %s!" % member.mention)
        await asyncio.sleep(mute_time)
        await member.edit(mute=False)
        await ctx.channel.send("Tu peux reparler %s!" % member.mention)

    @commands.command(help="Appuie sur la detente PUSSY!")
    async def roulette(self, ctx):
        mute_time = 60
        member = ctx.message.author
        barillet = [False, False, True, False, False]
        bullet = random.choice(barillet)
        if bullet == True:
            joke = self.bot.get_command('joke')
            await joke.invok(ctx, 'omawa_shindeiru.mp3')
            await member.edit(mute=True)
            await ctx.channel.send("Perdu, tu es mute pendant 60 secondes!")
        else:
            await ctx.channel.send("Gagné, tu ne seras pas mute!")
            return
        await asyncio.sleep(mute_time)
        await member.edit(mute=False)
        await ctx.channel.send("Tu peux reparler %s!" % member.mention)

    @tasks.loop(seconds=1.5)
    async def play_next(self):
        if self.sounds:
            audio_file,ctx = self.sounds[0]
            source = discord.PCMVolumeTransformer(discord.FFmpegPCMAudio(audio_file))
            if not ctx.voice_client.is_playing() and ctx.voice_client.is_connected():
                ctx.voice_client.play(source, after=lambda e: print('Player error: %s' % e) if e else None)
                self.sounds.pop(0)
                self.sounds_history.reverse()
                self.sounds_history.append((audio_file,ctx))
                self.sounds_history.reverse()
                if len(self.sounds_history) >5:
                    self.sounds_history = self.sounds_history[:5]

    @commands.command(help= "randomsur l'avenir des gens.")
    async def avenir(self, ctx):

        list_mot = ("tu seras curé, tu t'occuperas plus spécialement du catéchisme. ",
            "tu seras animateur de soirées pour les gays pride. ",
            "tu seras gynecologue dans une maison de retraite.",
            "tu iras vivre en thaïland à cause de ton job. car tu seras ladyboy dans un bar.",
            "tu sera DSI chez jacky et Michel",
            "tu seras arroseur de plante aquatique.")
        choix = random.choice(list_mot)
        await ctx.channel.send(choix)




def get_word(word_type):
    content = []
    with open("/home/mika/kabot/kabot/kabot/ressources/base_kml.xml", "r", encoding="ISO-8859-1") as file:
        content = file.readlines()
        content = "".join(content)
        bs_content = bs(content, 'lxml')
    if word_type == 'nom':
        nom = bs_content.resources.nom.find_all('word')
        result = random.choice(nom)
        return result
    elif word_type == 'nom_propre':
        nom_propre = bs_content.resources.nompropre.find_all('word')
        result = random.choice(nom_propre)
        return result
    elif word_type == 'verbe':
        verbe = bs_content.resources.verbe.find_all('word')
        result = random.choice(verbe)
        return result
    elif word_type == 'complement':
        complement = bs_content.resources.complement.find_all('word')
        result = random.choice(complement)
        return result
    elif word_type == 'nom_special':
        nom_special = bs_content.resources.complement.find_all('word')
        result = random.choice(nom_special)
        return result
    elif word_type == 'prenom':
        prenom = bs_content.resources.prenom.find_all('word')
        result = random.choice(prenom)
        return result
    elif word_type == 'prescuse':
        prescuse = bs_content.resources.prescuse.find_all('word')
        result = random.choice(prescuse)
        return result
    elif word_type == 'scuse1':
        scuse1 = bs_content.resources.scuse1.find_all('word')
        result = random.choice(scuse1)
        return result
    elif word_type == 'scuse2':
        scuse2 = bs_content.resources.scuse2.find_all('word')
        result = random.choice(scuse2)
        return result
    elif word_type == 'presulte':
        presulte = bs_content.resources.presulte.find_all('word')
        result = random.choice(presulte)
        return result
    elif word_type == 'sulte':
        sulte = bs_content.resources.sulte.find_all('word')
        result = random.choice(sulte)
        return result
    elif word_type == 'postsulte':
        postsulte = bs_content.resources.presulte.find_all('word')
        result = random.choice(postsulte)
        return result
    elif word_type == 'mail':
        mail = bs_content.resources.mail.find_all('word')
        result = random.choice(mail)
        return result
    else:
        result = 'Nique bien ta mère!'
    return result

def main():
    token = "NjI3MTM3NDY1MDA5ODMxOTQ2.XY4Raw.pw8sAen3bNR5aYsoTChQOudM0L8"
    bot = commands.Bot(command_prefix='!')

    test = False
    if "test" in argv[-1]:
        test=True

    @bot.event
    async def on_ready():
        print('yeah baby!')
        if test:
            await bot.logout()
        for channel in bot.get_all_channels():
            if channel.name == "général":
                current_chan = channel
        await current_chan.send('Le troll est dans la place !')
        ctx = await bot.get_context(current_chan.last_message)
        join = bot.get_command('join')
        await join.invoke(ctx)
        for channel in bot.get_all_channels():
            if channel.name == "Général":
                for member in channel.members:
                    await member.edit(mute=False)

    @aiocron.crontab('50 9-23/1 * * *')
    async def kron():
        kron_choice = random.choice(["kaamelott","slap","kamoulox",False, False, False])
        if kron_choice:
            await asyncio.sleep(random.choice(range(3550)))
            for channel in bot.get_all_channels():
                if channel.name == "général":
                    current_chan = channel
            ctx = await bot.get_context(current_chan.last_message)
            ctx.message.content = ""
            print(ctx.message.content)
            random_cmd = bot.get_command(kron_choice)
            await random_cmd.invoke(ctx)

    @aiocron.crontab('*/5 * * * *')
    async def pipelette():
        for channel in bot.get_all_channels():
            if channel.name == "Général" and\
                    len(channel.members) > 1 and\
                    random.choice([True,True,True]):
                for channel in bot.get_all_channels():
                    if channel.name == "général":
                        current_chan = channel
                await asyncio.sleep(random.choice(range(350)))
                ctx = await bot.get_context(current_chan.last_message)
                ctx.message.content = ""
                joke = bot.get_command('joke')
                await joke.invoke(ctx)

    @bot.event
    async def on_message(message):
        print(message.content)
        if message.author == bot.user:
            return
        else:
            if bot.user in message.mentions \
                    and len(message.mentions) < 3 \
                    and len(message.content.splitlines()) == 1:
                path = '/home/mika/.kabot/%s.log' % message.channel
                with open(path, 'r') as f :
                    lines = f.read().splitlines()
                if not message.content in lines:
                    with open(path, 'a') as f :
                        f.write(message.content + '\n')
                response = random.choice(lines).replace(str(bot.user.id), str(message.author.id))
                await message.channel.send(response)
        await bot.process_commands(message)

    @bot.event
    async def on_voice_state_update(member,before,after):
        if before.channel is None and after.channel:
            for channel in bot.get_all_channels():
                if channel.name == "général":
                    current_chan = channel
            ctx = await bot.get_context(current_chan.last_message)
            ctx.message.author = member
            welcome = bot.get_command('welcome')
            sleep(2)
            await welcome.invoke(ctx)

    bot.add_cog(Mybot(bot))
    bot.run(token)


if __name__ == "__main__":
    main()

